﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Threading;

namespace SampleApp01
{
    class Program
    {

        // 线程共享变量
        //static ThreadLocal<int> local = new ThreadLocal<int>();
        static AsyncLocal<int> local = new AsyncLocal<int>();

        static void Main(string[] args)
        {
            // 声明一个委托实例
            Action act = async () =>
             {
                 await RunAsync();
             };

            // 执行委托
            act();

            Console.Read();
        }

        static async Task RunAsync()
        {
            // 给共享变量赋值
            local.Value = 53000;
            // 输出变量的值
            Console.WriteLine($"异步等待前：{nameof(local)} = {local.Value}");
            await Task.Delay(50); //异步等待
            // 异步等待回来，再次输出变量的值
            Console.WriteLine($"异步等待后：{nameof(local)} = {local.Value}");
        }
    }
}
